/*
inithsh.c Version 0.1.0  Hash initialize database
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <stdlib.h>
#include <bthash.h>

#define MODE 0
#define TOTRCDS 1
#define RCDLEN 2
#define KEYLEN 3
#define KEYOFST 4
#define DLM 5

void putstx(char *pgm)
   {
   fprintf(stderr,"Initialize a hash database\n");
   fprintf(stderr,"Usage %s options filename\n", pgm);
   fprintf(stderr,"Options:\n");
   fprintf(stderr,"   -m mode\n");
   fprintf(stderr,"      mode = old for existing file\n");
   fprintf(stderr,"      mode = new for new file\n");
   fprintf(stderr,"      mode = any for old or new file\n");
   fprintf(stderr,"   -t integer for total records\n");
   fprintf(stderr,"   -r integer for record length\n");
   fprintf(stderr,"   -k integer for key length\n");
   fprintf(stderr,"   -o integer for key offset in record\n");
   fprintf(stderr,"Example: %s -m old "
      "-t 9973 -r 30 -k 10 -o 5 "
      "myfile.hsh\n", pgm);
   exit(1);
   } /* putstx */

int main(int argc, char **argv)
   {
   int i;
   int rslt;
   int argrslt;
   int truncflag;
   int totrcds;
   int rcdlen;
   int keylen;
   int keyofst;
   char fldlst[16];
   char dbname[256];
   if (argc != 12) putstx(*argv);
   strcpy(fldlst,"zzz");
   i = 1;
   while (i < 11)
      {
      rslt = strcmp(*(argv+i),"-m");
      if (!rslt)
	 {
	 argrslt = strcmp(*(argv+i+1),"old");
	 if (!argrslt)
	    {
	    truncflag = INITOLD;
	    fldlst[MODE] = 'x';
	    i = i + 2;
	    continue;
	    } /* old */
	 argrslt = strcmp(*(argv+i+1),"new");
	 if (!argrslt)
	    {
	    truncflag = INITNEW;
	    fldlst[MODE] = 'x';
	    i = i + 2;
	    continue;
	    } /* old */
	 argrslt = strcmp(*(argv+i+1),"any");
	 if (!argrslt)
	    {
	    truncflag = INITALL;
	    fldlst[MODE] = 'x';
	    i = i + 2;
	    continue;
	    } /* old */
	 fprintf(stderr,"Invalid mode %s\n",
	    *(argv+i+1));
	 putstx(*argv);
	 } /* mode */
      rslt = strcmp(*(argv+i),"-t");
      if (!rslt)
	 {
	 totrcds = atoi(*(argv+i+1));
	 fldlst[TOTRCDS] = 'x';
	 i = i + 2;
	 continue;
	 } /* total records */
      rslt = strcmp(*(argv+i),"-r");
      if (!rslt)
	 {
	 rcdlen = atoi(*(argv+i+1));
	 fldlst[RCDLEN] = 'x';
	 i = i + 2;
	 continue;
	 } /* record length */
      rslt = strcmp(*(argv+i),"-k");
      if (!rslt)
	 {
	 keylen = atoi(*(argv+i+1));
	 fldlst[KEYLEN] = 'x';
	 i = i + 2;
	 continue;
	 } /* key length */
      rslt = strcmp(*(argv+i),"-o");
      if (!rslt)
	 {
	 keyofst = atoi(*(argv+i+1));
	 fldlst[KEYOFST] = 'x';
	 i = i + 2;
	 continue;
	 } /* key offset */
      fprintf(stderr,"Invalid parameter %s\n",
	 *(argv+i));
      putstx(*argv);
      } /* for each parm */
   strcpy(dbname,*(argv+11));

   fldlst[DLM] = '\0';
   rslt = strcmp(fldlst,"xxxxx");

   if (rslt)
      {
      fprintf(stderr,"Incomplete parameter list\n");
      putstx(*argv);
      } /* incomplete parmlist */

   rslt = hinit(dbname,truncflag,
      totrcds, rcdlen, keylen, keyofst);

   return(0);
   } /* main */
