/*
schema.c Version 0.1.0  Hash Access Method: database size
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* Usage: schema filename */

#include <bthash.h>

void putstx(char *pgm)
   {
   fprintf(stderr,"Usage %s filename\n", pgm);
   exit(1);
   } /* putstx */

int main(int argc, char **argv)
   {
   int opnerr;
   hashfmt *hshhdr;
   char dbname[256];
   if (argc != 2) putstx(*argv);
   strcpy(dbname,*(argv+1));

   hshhdr = (hashfmt *) hopen(dbname,READ,&opnerr);
   if (hshhdr == NULL)
      {
      fprintf(stderr,"schema: hopen "
	 "error %d\n", opnerr);
      exit(1);
      } /* open err */
   /* process starts here */

   printf("schema: total records %9d\n",
      hshhdr->totrcds);
   printf("schema: record length %9d\n",
      hshhdr->rcdlen);
   printf("schema: key    length %9d\n",
      hshhdr->keylen);
   printf("schema: key    offset %9d\n",
      hshhdr->keyofst);

   /**********************************************************/
   hclose(hshhdr);
   return(0);
   } /* main */
